/*
 *  bignum_gcd.c
 *  BigMath
 *
 *  Created by Curtis Jones on 2007.08.05.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "bignum.h"

// 
// Knuth 1.1 - Algorithm E
//
// http://en.wikipedia.org/wiki/Euclidean_algorithm
//
bignum_t *
bignum_gcd (bignum_t *res, bignum_t *num1, bignum_t *num2)
{
//int i = 0;
//printf("%s().. starting\n", __PRETTY_FUNCTION__);
	
	bignum_t *a = bignum_alloc();
	bignum_t *b = bignum_alloc();
	bignum_t *t = bignum_alloc();
//bignum_t *x = NULL;
	
	bignum_set_bn(a, num1);
	bignum_set_bn(b, num2);
	
	while (!bignum_iszero(b))
	{
//	printf("%s().. while loop, iteration #%d\n", __PRETTY_FUNCTION__, (++i));
		
		bignum_set_bn(t, b);
		
//	x = t;										// swap t <=> b via x
//	t = b;										// store b in t for a, next time around
//	b = x;										// 
		
		bignum_mod(b, a, t);			// b = a % b
		
		bignum_set_bn(a, t);
		
//	x = a;										// swap a <=> t via x
//	a = t;										// set a to the previous value of b
//	t = x;										// 

//	printf("%s().. a @ %d = ", __PRETTY_FUNCTION__, (int)a); bignum_print(a);
//	printf("%s().. b @ %d = ", __PRETTY_FUNCTION__, (int)b); bignum_print(b);
//	printf("%s().. t @ %d = ", __PRETTY_FUNCTION__, (int)t); bignum_print(t);
//	printf("\n");
	}	
	
	bignum_set_bn(res, a);
	
	bignum_free( a );
	bignum_free( b );
	bignum_free( t );
	
//printf("%s().. ending\n", __PRETTY_FUNCTION__);
	
	return res;
}
