/*
 *  bignum_main.c
 *  BigMath
 *
 *  Created by Curtis Jones on 2007.08.05.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "bignum.h"

/*
 int
 main (int argc, char *argv[])
 {
	 bignum_t *num1 = bignum_alloc();
	 bignum_t *num2 = bignum_alloc();
	 bignum_t *num3 = bignum_alloc();
	 
	 bignum_set(num1, 2);
	 bignum_set(num2, 23);
	 
	 bignum_pow(num3, num1, num2);
	 
	 bignum_print( num3 );
	 
	 printf("bignum::main().. %lu**%lu = %lu\n", 2, 23, num3->numb[0]);
	 
	 return 0;
 }
 */

/*
 int
 main (int argc, char *argv[])
 {
	 srandomdev();
	 
	 u_int64_t i = 0;
	 u_int64_t g = 0;
	 u_int64_t b = 0;
	 u_int64_t t = 0;
	 
	 while (1) {
		 bignum_t * numA = bignum_alloc();
		 bignum_t * numB = bignum_alloc();
		 bignum_t * numC = bignum_alloc();
		 
		 struct timeval t1;
		 struct timeval t2;
		 
		 bzero(&t1, sizeof(struct timeval));
		 bzero(&t2, sizeof(struct timeval));
		 
		 bignum_set(numA, 0);
		 bignum_set(numB, 0);
		 bignum_set(numC, 0);
		 
		 u_int64_t size1 = rand() % 500;
		 u_int64_t size2 = rand() % 500;
		 
		 if (size1 > 1 && size2 > 1) {
			 bignum_rnd_mag(numA, size1);
			 bignum_rnd_mag(numB, size2);
			 
			 gettimeofday((struct timeval *)&t1, NULL);
			 bignum_gcd(numC, numA, numB);									// c = gcd(a, b)
			 gettimeofday((struct timeval *)&t2, NULL);
			 
			 t = ((t2.tv_sec * 1000000) + t2.tv_usec) - ((t1.tv_sec * 1000000) + t1.tv_usec);
			 
			 printf("bignum::main().. SUCCESS [count=%05llu, good=%05llu, bad=%05llu, size1=%04llu, size2=%04llu, time=%07.3f]\n", ++i, ++g, b, size1, size2, (t/1000.0));
			 bignum_print(numC);
			 
			 // sleep( 1 );
		 }
		 
		 bignum_free( numA );
		 bignum_free( numB );
		 bignum_free( numC );
	 }
	 
	 return 0;
 }
 */

/*
int
main (int argc, char *argv[])
{
	srandomdev();
	
	u_int64_t i = 0;
	u_int64_t g = 0;
	u_int64_t b = 0;
	u_int64_t t = 0;
	
	struct timeval t1;
	struct timeval t2;
	
	bignum_t * numA = bignum_alloc();
	bignum_t * numB = bignum_alloc();
	bignum_t * numC = bignum_alloc();
	bignum_t * numD = bignum_alloc();
	bignum_t * numE = bignum_alloc();
	bignum_t * numF = bignum_alloc();
	bignum_t * numR = bignum_alloc();
	
	int j = 0;
	
	//while (1) {
	for (j = 0; j < 1; ++j) {
		bzero(&t1, sizeof(struct timeval));
		bzero(&t2, sizeof(struct timeval));
		
		bignum_set(numA, 0);
		bignum_set(numB, 0);
		bignum_set(numC, 0);
		bignum_set(numD, 0);
		bignum_set(numE, 0);
		bignum_set(numF, 0);
		bignum_set(numR, 0);
		
		u_int64_t size1 = rand() % 5;
		u_int64_t size2 = rand() % 5;
		
		if (size1 > 1 && size2 > 1) {
			
			bignum_rnd_mag(numA, size1);
			bignum_rnd_mag(numB, size2);
			
			if (bignum_lt(numA, numB)) {
				bignum_t *tmp = numA;
				numA = numB;
				numB = tmp;
			}
			
			gettimeofday((struct timeval *)&t1, NULL);
			bignum_div(numC, numR, numA, numB);						// a / b = c * b + r
			bignum_mul(numD, numC, numB);									// c * b = d
			bignum_sub(numE, numA, numD);									// a - d = e
			bignum_add(numF, numD, numR);									// d + r = f = a
			gettimeofday((struct timeval *)&t2, NULL);
			
			t = ((t2.tv_sec * 1000000) + t2.tv_usec) - ((t1.tv_sec * 1000000) + t1.tv_usec);
			
			if (0 == bignum_cmp(numF, numA))
				printf("bignum::main().. SUCCESS [count=%05llu, good=%05llu, bad=%05llu, size1=%04llu, size2=%04llu, time=%07.3f]\n", ++i, ++g, b, size1, size2, (t/1000.0));
			else {
				printf("bignum::main().. FAILED  [count=%05llu, good=%05llu, bad=%05llu, size1=%04llu, size2=%04llu, time=%07.3f]\n", ++i, g, ++b, size1, size2, (t/1000.0));
				
				printf("bignum::main().. A = ");
				bignum_print( numA );
				printf("bignum::main().. B = ");
				bignum_print( numB );
				printf("bignum::main().. C = ");
				bignum_print( numC );
				printf("bignum::main().. D = ");
				bignum_print( numD );
				printf("bignum::main().. E = ");
				bignum_print( numE );
				printf("bignum::main().. F = ");
				bignum_print( numF );
				printf("bignum::main().. R = ");
				bignum_print( numR );
			}
			
			//		sleep( 1 );
		}
	}
	
	bignum_free( numA );
	bignum_free( numB );
	bignum_free( numC );
	bignum_free( numD );
	bignum_free( numE );
	bignum_free( numF );
	bignum_free( numR );
	
	return 0;
}
*/

/*
 int
 main (int argc, char *argv[])
 {
	 bignum_t * a = bignum_alloc();
	 bignum_t * b = bignum_alloc();
	 bignum_t * c = bignum_alloc();
	 
	 //bignum_set(a, 4864);
	 //bignum_set(b, 3458);
	 
	 bignum_set(a, 1529);
	 bignum_set(b, 2356);
	 
	 bignum_modinv(c, a, b);
	 
	 bignum_print( a );
	 bignum_print( b );
	 bignum_print( c );
	 
	 return EXIT_SUCCESS;
 }
 */

/*
int
main (int argc, char *argv[])
{
	bignum_t * a = bignum_alloc();
	bignum_t * b = bignum_alloc();
	bignum_t * c = bignum_alloc();
	bignum_t * d = bignum_alloc();
	
//bignum_set(a, 1529);
//bignum_set(b, 2356);
	
	bignum_set_ui8(a, 3, (BIGNUM_BASE_TYPE[]){0x12345678, 0x23456789, 0x00012345});
//bignum_set_ui8(b, 3, (BIGNUM_BASE_TYPE[]){0x12345678, 0x23456789, 0x00012344});
	bignum_set_ui8(b, 2, (BIGNUM_BASE_TYPE[]){0x98765432, 0x45126734});
	
//bignum_sub(c, a, b);
//bignum_sub(c, b, a);
	bignum_mul(c, a, b);
	bignum_div(d, NULL, c, b);
	
	bignum_print( a );
	bignum_print( b );
	bignum_print( c );
	bignum_print( d );
	
	return EXIT_SUCCESS;
}
*/

/* Add two random numbers. Verify the result 
 * with subtraction.
 *
 * Return zero on success, non-zero otherwise.
 *
 */
int
test_bignum_add (bignum_t *num_a, bignum_t *num_b)
{
	u_int64_t t = 0;
	struct timeval t1, t2;
	bignum_t * num_c = bignum_alloc();
	bignum_t * num_d = bignum_alloc();
	char str_a[15], str_b[15], str_c[15], str_d[15];
	
	bzero(&t1, sizeof(struct timeval));
	bzero(&t2, sizeof(struct timeval));
	
	gettimeofday((struct timeval *)&t1, NULL);
	bignum_add(num_c, num_a, num_b);
	gettimeofday((struct timeval *)&t2, NULL);
	bignum_sub(num_d, num_c, num_b);
	
	bignum_cstr_base(num_a, 15, str_a, 10);
	bignum_cstr_base(num_b, 15, str_b, 10);
	bignum_cstr_base(num_c, 15, str_c, 10);
	bignum_cstr_base(num_d, 15, str_d, 10);
	
	t = ((t2.tv_sec * 1000000) + t2.tv_usec) - ((t1.tv_sec * 1000000) + t1.tv_usec);
	
	if (bignum_eq(num_a,num_d))
		printf(" [T | %07.3f] %s + %s = %s and %s - %s = %s\n", (t/1000.0), str_a, str_b, str_c, str_c, str_b, str_d);
	else
		printf(" [F | %07.3f] %s + %s = %s and %s - %s = %s\n", (t/1000.0), str_a, str_b, str_c, str_c, str_b, str_d);
	
	bignum_free( num_c );
	bignum_free( num_d );
	
	return 0;
}

/**
 *
 *
 */
int
test_bignum_sub (bignum_t *num_a, bignum_t *num_b)
{
	u_int64_t t = 0;
	struct timeval t1, t2;
	bignum_t * num_c = bignum_alloc();
	bignum_t * num_d = bignum_alloc();
	char str_a[15], str_b[15], str_c[15], str_d[15];
	
	bzero(&t1, sizeof(struct timeval));
	bzero(&t2, sizeof(struct timeval));
	
	gettimeofday((struct timeval *)&t1, NULL);
	bignum_sub(num_c, num_a, num_b);
	gettimeofday((struct timeval *)&t2, NULL);
	bignum_add(num_d, num_c, num_b);
	
	bignum_cstr_base(num_a, 15, str_a, 10);
	bignum_cstr_base(num_b, 15, str_b, 10);
	bignum_cstr_base(num_c, 15, str_c, 10);
	bignum_cstr_base(num_d, 15, str_d, 10);
	
	t = ((t2.tv_sec * 1000000) + t2.tv_usec) - ((t1.tv_sec * 1000000) + t1.tv_usec);
	
	if (bignum_eq(num_a,num_d))
		printf(" [T | %07.3f] %s - %s = %s and %s + %s = %s\n", (t/1000.0), str_a, str_b, str_c, str_c, str_b, str_d);
	else
		printf(" [T | %07.3f] %s - %s = %s and %s + %s = %s\n", (t/1000.0), str_a, str_b, str_c, str_c, str_b, str_d);
	
	bignum_free( num_c );
	bignum_free( num_d );
	
	return 0;
}

/**
 *
 *
 */
int
test_bignum_mul (bignum_t *num_a, bignum_t *num_b)
{
	u_int64_t t = 0;
	struct timeval t1, t2;
	bignum_t * num_c = bignum_alloc();
	bignum_t * num_d = bignum_alloc();
	bignum_t * num_e = bignum_alloc();
	char str_a[15], str_b[15], str_c[15], str_d[15], str_e[15];
	
	bzero(&t1, sizeof(struct timeval));
	bzero(&t2, sizeof(struct timeval));
	
	gettimeofday((struct timeval *)&t1, NULL);
	bignum_mul(num_c, num_a, num_b);
	gettimeofday((struct timeval *)&t2, NULL);
	bignum_div(num_d, num_e, num_c, num_b);
	
	bignum_cstr_base(num_a, 15, str_a, 10);
	bignum_cstr_base(num_b, 15, str_b, 10);
	bignum_cstr_base(num_c, 15, str_c, 10);
	bignum_cstr_base(num_d, 15, str_d, 10);
	bignum_cstr_base(num_e, 15, str_e, 10);
	
	t = ((t2.tv_sec * 1000000) + t2.tv_usec) - ((t1.tv_sec * 1000000) + t1.tv_usec);
	
	if (bignum_eq(num_a,num_d))
		printf(" [T | %07.3f] %s * %s = %s and %s / %s = %s r %s\n", (t/1000.0), str_a, str_b, str_c, str_c, str_b, str_d, str_e);
	else
		printf(" [F | %07.3f] %s * %s = %s and %s / %s = %s r %s\n", (t/1000.0), str_a, str_b, str_c, str_c, str_b, str_d, str_e);
	
	bignum_free( num_c );
	bignum_free( num_d );
	bignum_free( num_e );
	
	return 0;
}

/**
 *
 *
 */
int
test_bignum_div (bignum_t *num_a, bignum_t *num_b)
{
	u_int64_t t = 0;
	struct timeval t1, t2;
	bignum_t * num_c = bignum_alloc();
	bignum_t * num_d = bignum_alloc();
	bignum_t * num_e = bignum_alloc();
	bignum_t * num_f = bignum_alloc();
	char str_a[15], str_b[15], str_c[15], str_d[15], str_f[15];
	
	bzero(&t1, sizeof(struct timeval));
	bzero(&t2, sizeof(struct timeval));
	
	gettimeofday((struct timeval *)&t1, NULL);
	bignum_div(num_c, num_d, num_a, num_b);
	gettimeofday((struct timeval *)&t2, NULL);
	bignum_mul(num_e, num_c, num_b);
	bignum_add(num_f, num_e, num_d);
	
	bignum_cstr_base(num_a, 15, str_a, 10);
	bignum_cstr_base(num_b, 15, str_b, 10);
	bignum_cstr_base(num_c, 15, str_c, 10);
	bignum_cstr_base(num_d, 15, str_d, 10);
	bignum_cstr_base(num_f, 15, str_f, 10);
	
	t = ((t2.tv_sec * 1000000) + t2.tv_usec) - ((t1.tv_sec * 1000000) + t1.tv_usec);
	
	if (bignum_eq(num_a,num_f))
		printf(" [T | %07.3f] %s / %s = %s r%s and %s * %s + %s = %s\n", (t/1000.0), str_a, str_b, str_c, str_d, str_c, str_b, str_d, str_f);
	else
		printf(" [F | %07.3f] %s / %s = %s r%s and %s * %s + %s = %s\n", (t/1000.0), str_a, str_b, str_c, str_d, str_c, str_b, str_d, str_f);
	
	bignum_free( num_c );
	bignum_free( num_d );
	bignum_free( num_e );
	bignum_free( num_f );
	
	return 0;
}

/**
 * Randomly tests and verifies the basic arithmetic operations.
 *
 *
 */
/*
int
main (int argc, char *argv[])
{
	srandomdev();
	
	bignum_t * num_a = bignum_alloc();
	bignum_t * num_b = bignum_alloc();
	
	while (1)
	{
		int op = rand() % 4;
		
		u_int64_t oofm_a = rand() % 1000;
		u_int64_t oofm_b = rand() % 1000;
		
		bignum_rnd_mag(num_a, oofm_a);
		bignum_rnd_mag(num_b, oofm_b);
		
		switch (op) {
			case 0: test_bignum_add(num_a, num_b); break;
			case 1: test_bignum_sub(num_a, num_b); break;
			case 2: test_bignum_mul(num_a, num_b); break;
			case 3: test_bignum_div(num_a, num_b); break;
		};
	}
	
	bignum_free(num_a);
	bignum_free(num_b);
	
	return EXIT_SUCCESS;
}
*/

/**
 * Determines the average execution time for various operations.
 *
 *
 */
/*
int
main (int argc, char *argv[])
{
	srandomdev();
	
	struct timeval t1, t2;
	
	bignum_t * num_a = bignum_alloc();
	bignum_t * num_b = bignum_alloc();
	bignum_t * num_c = bignum_alloc();
	bignum_t * num_d = bignum_alloc();
	
	u_int64_t average = 0;
	u_int64_t count = 0;
	u_int64_t oofm_a = rand() % 1000;
	u_int64_t oofm_b = rand() % 1000;
	
	//
	// ADD
	//
	
	for (average=0, count=0; count < 10000; ++count) {
		bzero(&t1, sizeof(struct timeval));
		bzero(&t2, sizeof(struct timeval));
		
		bignum_rnd_mag(num_a, oofm_a);
		bignum_rnd_mag(num_b, oofm_b);
		
		gettimeofday((struct timeval *)&t1, NULL);
		bignum_add(num_c, num_a, num_b);
		gettimeofday((struct timeval *)&t2, NULL);
		
		u_int64_t tmp = ((t2.tv_sec * 1000000) + t2.tv_usec) - ((t1.tv_sec * 1000000) + t1.tv_usec);
		
		if (count == 0)
			average = tmp;
		else
			average = ((average * count) + tmp) / (count+1);
	}
	
	printf("bignum::main().. ADD cnt=%llu; avg=%llu\n", count, average);
	
	
	//
	// SUB
	//
	
	for (average=0, count=0; count < 10000; ++count) {
		bzero(&t1, sizeof(struct timeval));
		bzero(&t2, sizeof(struct timeval));
		
		bignum_rnd_mag(num_a, oofm_a);
		bignum_rnd_mag(num_b, oofm_b);
		
		gettimeofday((struct timeval *)&t1, NULL);
		bignum_sub(num_c, num_a, num_b);
		gettimeofday((struct timeval *)&t2, NULL);
		
		u_int64_t tmp = ((t2.tv_sec * 1000000) + t2.tv_usec) - ((t1.tv_sec * 1000000) + t1.tv_usec);
		
		if (count == 0)
			average = tmp;
		else
			average = ((average * count) + tmp) / (count+1);
	}
	
	printf("bignum::main().. SUB cnt=%llu; avg=%llu\n", count, average);
	
	
	//
	// MUL
	//
	
	for (average=0, count=0; count < 100; ++count) {
		bzero(&t1, sizeof(struct timeval));
		bzero(&t2, sizeof(struct timeval));
		
		bignum_rnd_mag(num_a, oofm_a);
		bignum_rnd_mag(num_b, oofm_b);
		
		gettimeofday((struct timeval *)&t1, NULL);
		bignum_mul(num_c, num_a, num_b);
		gettimeofday((struct timeval *)&t2, NULL);
		
		u_int64_t tmp = ((t2.tv_sec * 1000000) + t2.tv_usec) - ((t1.tv_sec * 1000000) + t1.tv_usec);
		
		if (count == 0)
			average = tmp;
		else
			average = ((average * count) + tmp) / (count+1);
	}
	
	printf("bignum::main().. MUL cnt=%llu; avg=%llu\n", count, average);
	
	//
	// DIV
	//
	
	for (average=0, count=0; count < 100; ++count) {
		bzero(&t1, sizeof(struct timeval));
		bzero(&t2, sizeof(struct timeval));
		
		bignum_rnd_mag(num_a, oofm_a);
		bignum_rnd_mag(num_b, oofm_b);
		
		gettimeofday((struct timeval *)&t1, NULL);
		bignum_div(num_c, num_d, num_a, num_b);
		gettimeofday((struct timeval *)&t2, NULL);
		
		u_int64_t tmp = ((t2.tv_sec * 1000000) + t2.tv_usec) - ((t1.tv_sec * 1000000) + t1.tv_usec);
		
		if (count == 0)
			average = tmp;
		else
			average = ((average * count) + tmp) / (count+1);
	}
	
	printf("bignum::main().. DIV cnt=%llu; avg=%llu\n", count, average);
	
	bignum_free(num_a);
	bignum_free(num_b);
	bignum_free(num_c);
	bignum_free(num_d);
	
	return EXIT_SUCCESS;
}
*/

/**
 * Rubik's cube stuff.
 *
 */
/*
int
main (int argc, char *argv)
{
	bignum_init();
	
	bignum_t * c_fac = bignum_alloc();
	bignum_t * e_fac = bignum_alloc();
	bignum_t * c_pow = bignum_alloc();
	bignum_t * e_pow = bignum_alloc();
	bignum_t * c_tot = bignum_alloc();
	bignum_t * e_tot = bignum_alloc();
	bignum_t * total = bignum_alloc();
	bignum_t * tmp1  = bignum_alloc();
	
	char strbuf[15] = { 0 };
	
	bignum_factorial(c_fac, bignum_eight());
	bignum_pow(c_pow, bignum_three(), bignum_seven());
	bignum_mul(c_tot, c_fac, c_pow);
	
	bignum_factorial(e_fac, bignum_twelve());
	bignum_pow(e_pow, bignum_two(), bignum_eleven());
	bignum_mul(e_tot, e_fac, e_pow);
	
	bignum_mul(tmp1, c_tot, e_tot);
	bignum_div(total, NULL, tmp1, bignum_two());
	
	bignum_cstr_base(total, 15, strbuf, 10);
	
	printf("main::main().. total = %s\n", strbuf);
	
	bignum_free(c_fac);
	bignum_free(e_fac);
	bignum_free(total);
	
	return EXIT_SUCCESS;
}
*/

/**
 * Factorial test.
 *
 */
int
main (int argc, char *argv)
{
	bignum_init();
	
	bignum_t * num1 = bignum_alloc();
	bignum_t * num2 = bignum_alloc();
	
//char num1str[15] = { 0 };
//char num2str[15] = { 0 };
	
	bignum_set(num1, 10000);
	
	bignum_factorial(num2, num1);
	
//bignum_cstr_base(num1, 15, num1str, 10);
//bignum_cstr_base(num2, 15, num2str, 10);
//
//printf("main::main().. %s! = %s\n", num1str, num2str);
	
	bignum_free(num1);
	bignum_free(num2);
	
	return EXIT_SUCCESS;
}
