/*
 *  bignum_prime.c
 *  BigMath
 *
 *  Created by Curtis Jones on 2008.03.11.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

#include "bignum.h"

// http://www.luschny.de/math/factorial/index.html

/*
 NOTES
 
 Use a bignum_t for the sieve itself - needing only one bit per number.
 Use a bignum_t for specifying the offset of the bit we want to get/set.
 
 Do we need a bignum_prime_sieve_t type?
 
 Let limit be the size of the sieve (ie, highest possible prime value).
 
 Create a new bignum_t.
 
 Initialize the size of the bignum_t to oofm = (limit / sizeof(BASE_TYPE)) + 1.
  - could this list possibly be half the size, if we assume no even numbers 
    will be represented in the list? ie, offset / 2? is the memory savings of
    this approach worth the cost of the additional division operations?
 
 Create a results list (ie, each found prime).
   - can we support this results list notion without allocating a bignum_t for
     every result?
   - this results list is going to have to be able to grow. we need an mutable
     array type....
 
 Initialize results list with 2, 3, 5.
 
 For each entry in the sieve list (based on mod 60):
 
   1. 
   2. 
   3. 
   4. 
 
 Start with the lowest number in the sieve list:
 
   Take the next number in sieve list still marked prime.
 
   Include the number in the results list.
 
   Square the number and mark all multiples of that square as non-prime.
 
   Loop.
 
 
 
 */
